          ;
;+----------------------------------------------------------------------------+
;|                                                                            |
;|                         BOOT1P00.ASM                                       |
;|                                                                25/06/2005  |
;+----------------------------------------------------------------------------+
;
; Escrito com editor JFE usando "soft tab = 18"
;
; Fazer o BOOT do PENTACONTROLADOR (P5C) - SERIAL - USB - PARALELA
;
; SW4 (P1.0) permite mudar o baud rate
;
; Inclui rotinas de TESTE para auxiliar na montagem e teste da placa
; Ao fazer o RESET com SW4 (P1.0) acionada a placa entra no MODO TESTE
;
;             LEDS QUADRADOS
;AMARELO  ==> botao de reset acionado
;VERDE    ==> pronto para receber dados pela porta serial
;VERMELHO ==> modo single step
;


$MOD51
;$NOPRINT

; Incluir arquivo com declaracao de constantes e variaveis
$INCLUDE (CABEC.ASM)

;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	Inicio das Rotinas                                           ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
	ORG	RESET
                	LJMP      	INICIO	;SALTAR PARA INCIO DO PROGRAMA

	ORG	INT_EXTERNA_0	;INTERRUPO EXTERNA 0
                	LJMP           	EXTERNA_0             

	ORG	INT_TIMER_0	;INTERRUPO TIMER 0
                	LJMP            	TIMER_0

	ORG	INT_EXTERNA_1	;INTERRUPO EXTERNA 1
                	LJMP            	EXTERNA_1

	ORG	INT_TIMER_1	;INTERRUPO TIMER 1
	;

	ORG	INT_SERIAL	;INTERRUPO SERIAL
                	LJMP            	SERIAL
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	Mensagens usadas pelo sistema                               ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
	ORG	50H
LCD_MSG1:	DB	'BOOT P5C SER USB',0
LCD_MSG2:	DB	' V01.00  PARALEL',0
LCD_MSG3:	DB	'PRONTO !',0
LCD_MSG4:	DB	'BYTES',0
LCD_MSG5:	DB	'-TESTE-',0
LCD_MSG_BAUD:	DB	'BAUD =  ',0
LCD_MSG_4800:	DB	' 4800bps',0
LCD_MSG_9600:	DB	' 9600bps',0
LCD_MSG_14400:	DB	'14400bps',0
LCD_MSG_28800:	DB	'28800bps',0

SER_MSG1:	DB	'BOOT DO PENTACONTROLADOR, VERSAO 01.00.',CR,LF,0
SER_MSG2:	DB	'PRONTO PARA BOOT: SERIAL - USB -  PARALELO ...',CR,LF,0
SER_MSG3:	DB	'SERIAL =  9.600 bps, 8 BITS DE DADOS, 2 DE PARADA, SEM PARIDADE.',CR,LF,0
SER_MSG_4800:	DB	'SERIAL =  4.800 bps.',CR,LF,0
SER_MSG_9600:	DB	'SERIAL =  9.600 bps.',CR,LF,0
SER_MSG_14400:	DB	'SERIAL = 14.400 bps.',CR,LF,0
SER_MSG_28800:	DB	'SERIAL = 28.800 bps.',CR,LF,0

MSG_ERRO0:	DB              	'ERRO=0',0
MSG_ERRO1:	DB              	'ERRO=1',0
MSG_ERRO2:	DB              	'ERRO=2',0
MSG_ERRO3:	DB              	'ERRO=3',0
MSG_ERRO4:	DB              	'ERRO=4',0
MSG_ERRO5:	DB      	'ERRO=5',0


	ORG             	200H
INICIO:	MOV             	R0,#127         	;ZERAR RAM INTERNA
                	CLR             	A
IN1:            	MOV             	@R0,A
                	DJNZ            	R0,IN1
	MOV             	SP,#SP_INIC       ;INCIALIZAR PILHA
                    

	MOV	R7,#REBOTE_SW4
	CLR	C
IN2:	ORL	C,SW4           ;LER CHAVE SW3 DIVERSAS VEZES
	DJNZ	R7,IN2
	JC	IN3
	LJMP	MODO_TESTE             

IN3:	MOV             	TMOD,#21H         ;TIMER1 MODO2, TIMER0 MODO 1
                	MOV             	TH1,#BAUD_28800     ;BAUD = 28800
                	MOV             	TL1,#BAUD_28800
	MOV	TL0,#LOW  REC50MS	;GERAR OS 50 mSEG
	MOV	TH0,#HIGH REC50MS	;GERAR OS 50 mSEG
	MOV	SCON,#0C8H	;8 DADOS,1 START,2 STOP
                	MOV             	TCON,#50H         ;TR0=1 e TR1=1

	LCALL	APAGA_LEDS

                    
                    SETB	ET0
                    SETB	EA
                    
                    SETB	PISCA_AM
 	MOV	CDT,#0
	MOV	R0,#FILA
	MOV	R1,#(FILA+TAM-1)
                    
	MOV	DPTR,#SER_MSG1
                    LCALL	SER_STRC

	MOV	DPTR,#SER_MSG2
                    LCALL	SER_STRC
             
	MOV	DPTR,#SER_MSG_28800
                    LCALL	SER_STRC
                  
	LCALL	LCD_ESTA_OK	;VERIFICAR SE O LCD EST PRESENTE E FUNCIONANDO
	LCALL	LCD_INIC	;INICIALIZAR O LCD

	MOV	DPTR,#LCD_MSG1
	LCALL	LCD_STRC

                    MOV                 A,#40H
                    LCALL               LCD_CURSOR

	MOV	DPTR,#LCD_MSG2
	LCALL	LCD_STRC

                    SETB	ES
                    SETB	PS
	SETB	REN	;HABILITA REC SERIAL

LBX2:	JB	COMECOU,LBX0	;SALTAR PARA INCIO DA RECEPO
	JB	SW4,LBX2	;NO ACIONOU SW4
                    CLR	ES	;DESABILITAR INT SERIAL
	LCALL	SELEC_BAUD	;PARA IMPRIMIR MENSAGENS
	SETB	ES	;DE BAUD RATE
                    SJMP	LBX2

;
; Aqui inicia a recepcao INTEL.HEX
;

LBX0:	LCALL	LCD_APAGA	;APAGAR LCD
INTEL_HEX:	LCALL	VEM_BYTE	;ESPERAR BYTE
TP6:	SETB	PISCA_VD	;PISCAR VERDE
	XRL	A,#':'	;CHEGOU ':'
	JZ	LB2
	LJMP	ERRO0	;FALTOU ':'
LB2:	MOV	R5,#0	;R5=CHECK SUM
	LCALL	VEM_BIN_XEQ
	MOV	R6,A	;R6 CONTA OS BYTES
	LCALL	VEM_BIN_XEQ	;ADR HIGH
	MOV	DPH,A
	LCALL	VEM_BIN_XEQ	;ADR LOW
	MOV	DPL,A	;DPTR=ADR DE CARGA
	LCALL	VEM_BIN_XEQ	;RECEBER TIPO
	JZ	REC_DADO	;TIPO=0
	CJNE	A,#1,LB4
	SETB	FIM	;AVISAR CHEGOU ULTIMO RECORD
	SJMP	XEQ_SUM
LB4:	LJMP	ERRO1	;TIPO DESCONHECIDO
REC_DADO:	LCALL	VEM_BIN_XEQ	;RECEBER DADO A SER CARREGADO
	MOVX	@DPTR,A	;ESCREVER DADO NA RAM
	INC	DPTR
	DJNZ	R6,REC_DADO	;FOI O ULTIMO ?
XEQ_SUM:	LCALL	VEM_BIN	;RECEBER O CHECK SUM
	ADD	A,R5	;CONFERIR O CHECK SUM
	JZ	LB5
	LJMP	ERRO2	;NAO CONFERIU CHECK SUM
LB5:	LCALL	VEM_BYTE	;RECEBER 0DH
	SWAP	A
	MOV	B,A
	LCALL	VEM_BYTE	;RECEBER 0AH
	ADD	A,B	;MONTAR 0DAH
	XRL	A,#CRLF
	JZ	LB6
	LJMP	ERRO0
LB6:	JNB	FIM,INTEL_HEX
	CLR	REN
                    LCALL	APAGA_LEDS
	CLR	PISCA_AM 	;LED AMARELO NAO PISCA
	SETB	PISCA_VD	;LED VERDE PISCA
	LCALL	LCD_INIC
	;MOV	A,#0
	;LCALL	LCD_DDRAM
	MOV	DPTR,#LCD_MSG3
	LCALL	LCD_STRC
	
	MOV	A,#40H
	LCALL	LCD_DDRAM	;CURSOR POSICAO 40H
	MOV	A,CONTH
	LCALL	LCD_BCD2
	MOV	A,CONTM
	LCALL	LCD_BCD2
	MOV	A,CONTL
	LCALL	LCD_BCD2
	;LCALL	IMP_CONT
                    MOV	A,#48H
                    LCALL	LCD_CURSOR
                    MOV	DPTR,#LCD_MSG4
                    LCALL	LCD_STRC
	SJMP	$	;TERMINOU
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                        VEM_BIN_XEQ                                 ;
; Retirar 2 bytes da fila e montar um byte                           ;
; Recebe : nada                                                      ;
; Retorna: Acc=byte montado e ja faz o check sum em R5               ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
VEM_BIN_XEQ:	LCALL	TIRA
	JNC	VEM_BIN_XEQ	;PEGAR O MSNibble
	MOV	B,A	;GUARDAR O MSNibble
VEM1:	LCALL	TIRA	;PEGAR O LSNibble
	JNC	VEM1
	LCALL	ASC_HEXT	;CONVERTER PARA HEXA
	MOV	B,A
	ADD	A,R5	;CHECK SUM
	MOV	R5,A
	MOV	A,B
	RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                        VEM_BIN                                     ;
; Retirar 2 bytes da fila e montar um byte                           ;
; Recebe : nada                                                      ;
; Retorna: Acc=byte montado                                          ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
VEM_BIN:	LCALL	TIRA
	JNC	VEM_BIN	;PEGAR O MSNibble
	MOV	B,A	;GUARDAR O MSNibble
VEM2:	LCALL	TIRA	;PEGAR O LSNibble
	JNC	VEM2
	LCALL	ASC_HEXT	;CONVERTER PARA HEXA
	RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                        VEM_BYTE                                    ;
; Retirar 1 byte da fila                                             ;
; Recebe : nada                                                      ;
; Retorna: Acc=byte                                                  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
VEM_BYTE:       	LCALL	TIRA
	JNC	VEM_BYTE	;ESPERAR CHEGAR DADO
	RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                          ASC_HEXT (com teste)                      ;
; Converter dois caracteres HEXA ASCII no hexadecimal binario        ;
; Recebe  : Acc=LSN  B=MSN                                           ;
; Retorna : Acc=byte                                                 ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
ASC_HEXT:	LCALL	ASC_NIBT	;CONVERTER LSNibble
	XCH	A,B
	LCALL	ASC_NIBT	;CONVERTER MSNibble
	SWAP	A
	ADD	A,B
	RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                          ASC_NIBT                                  ;
; Converter um nibble que esta em ASCII no binario (Faz teste)       ;
; Recebe  : Acc=nibble(ASCII)                                        ;
; Retorna : Acc=nibble(binario)                                      ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
ASC_NIBT:	CLR	C
	SUBB	A,#30H	;A-30H SE CY=1 --> A<30H
	JC	ERRO	;      SE CY=0 --> A>=30H
	PUSH	ACC
	SUBB	A,#10	;A-10 SE CY=1 --> A<10
	JNC	ASCNIB1	;     SE CY=0 --> A>=10
	POP	ACC
	RET
ASCNIB1:	POP	ACC
	SUBB	A,#17H	;A-17H SE CY=1 --> A<17H
	JNC	ERRO	;      SE CY=0 --> A>=17H(ERRO)
	ADD	A,#10H
	RET
ERRO:	LJMP	ERRO4

;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                             POE                                    ;
; Rotina para colocar um byte na fila circular                       ;
; R0 = pin E R1 = pout                                               ;
; Recebe Acc=byte                                                    ;
; Retorna: CY=1 se conseguiu colocar na fila                         ;
;          CY=0 se nao foi possivel colocar na fila (cheia)          ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
POE:	PUSH	ACC
	MOV	A,R0
	XRL	A,R1
	JNZ	POE1
	POP	ACC	;PIN=POUT --> FILA CHEIA
	CLR	C
	RET
POE1:	POP	ACC	;TEM ESPACO
	MOV	@R0,A	;COLOCAR NA FILA
	INC	R0
	CJNE	R0,#(FILA+TAM),POE2
	MOV	R0,#FILA	;RESTAURAR PARA INICIO
POE2:	SETB	C
	RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                           TIRA                                     ;
; Rotina para tirar um byte na fila circular                         ;
; Recebe : nada                                                      ;
; Retorna: CY=1 e Acc=byte se conseguiu retirar da fila              ;
;          CY=0 se a fila estava vazia                               ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
TIRA:	JNB	FLAG_TEMPO,TIRA3
	MOV	CDT,#0                   
	MOV	A,#40H
	LCALL	LCD_DDRAM	;CURSOR POSICAO 40H
	MOV	A,CONTH
	LCALL	LCD_BCD2
	MOV	A,CONTM
	LCALL	LCD_BCD2
	MOV	A,CONTL
	LCALL	LCD_BCD2
TIRA3:	MOV	A,R1
	INC	A
	CJNE	A,#(FILA+TAM),TIRA1	;FIM DA FILA
	MOV	A,#FILA	;RESTAURAR INICIO
TIRA1:	PUSH	ACC
	XRL	A,R0
	JNZ	TIRA2	;POUT=PIN ?
	POP	ACC
	CLR	C	;FILA VAZIA
	RET
TIRA2:	POP	ACC
	MOV	R1,A
	MOV	A,@R1
	SETB	C
	RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                    ROTINAS INTERRUPCAO                             ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                           SERIAL - Interrupcao                     ;
; Chama rotina POE e coloca byte recebido na fila                    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
SERIAL:	JNB	TI,SER1
	CLR	TI
                    RETI
SER1:	PUSH	PSW	;GUARDAR CONTEXTO
	PUSH	ACC
	CLR	RI
                    SETB	COMECOU
	MOV	A,CONTL	;INC CONTADOR (BCD) DE BYTES
	ADD	A,#1	; [CONTH:CONTM:CONTL]
	DA	A
	MOV	CONTL,A
	MOV	A,CONTM
	ADDC	A,#0
	DA	A
	MOV	CONTM,A
	MOV	A,CONTH
	ADDC	A,#0
	DA	A
	MOV	CONTH,A
	MOV	A,SBUF	;LER DADO RECEBIDO
	LCALL	POE	;POR NA FILA
	JC	SER3
	LJMP	ERRO3	;FILA CHEIA
SER3:	POP	ACC 	;RESTAURAR CONTEXTO
	POP	PSW
	RETI

;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	SELEC_BAUD			;
; Selecionar Baud Rate com a chave SW4 4.800 - 9.600 - 14.400 - 28.800	;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                       
SELEC_BAUD:	LCALL               LCD_APAGA;          ;APAGA E HOME
                    MOV	A,TH1
                    CJNE                A,#BAUD_28800,LBX3  ;
                    MOV                 TH1,#BAUD_4800      ;4800 BPS
                    MOV                 DPTR,#SER_MSG_4800
                    LCALL               SER_STRC
                    MOV                 DPTR,#LCD_MSG_4800
                    LCALL               LCD_STRC
                    SJMP                LBX10
LBX3:	CJNE	A,#BAUD_4800,LBX4	;
                    MOV	TH1,#BAUD_9600	;9600 BPS
                    MOV	DPTR,#SER_MSG_9600
                    LCALL               SER_STRC
                    MOV                 DPTR,#LCD_MSG_9600
                    LCALL               LCD_STRC
                    SJMP                LBX10
LBX4:               CJNE                A,#BAUD_9600,LBX5   ;
                    MOV                 TH1,#BAUD_14400     ;14400 BPS
                    MOV                 DPTR,#SER_MSG_14400
                    LCALL               SER_STRC
                    MOV                 DPTR,#LCD_MSG_14400
                    LCALL               LCD_STRC
                    SJMP                LBX10
LBX5:               MOV                 TH1,#BAUD_28800     ;DEFAULT
                    MOV                 DPTR,#SER_MSG_28800 ;28800 BPS
                    LCALL               SER_STRC
                    MOV                 DPTR,#LCD_MSG_28800
                    LCALL               LCD_STRC
LBX10:              LCALL               SW4_AB_FECH
                    LCALL               SW4_FECH_AB
                    LCALL               LCD_APAGA
                    
                    MOV                 DPTR,#LCD_MSG1      ;REESCREVER
                    LCALL               LCD_STRC            ;MSG ORIGINAL
                    MOV                 A,#40H
                    LCALL               LCD_CURSOR
                    MOV                 DPTR,#LCD_MSG2
                    LCALL               LCD_STRC

                    RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                           SW1_AB_FECH                                       ;
; Eliminar rebotes da chave SW1 na transiao de ABERTA para FECHADA                 ;
; Usa R7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                             ;
SW1_AB_FECH:        MOV                 R7,#REBOTE_SW4
LBX8:               JB                  SW1,SW1_AB_FECH     ;CHAVE ABERTA
                    DJNZ                R7,LBX8             ;DECREMENTAR CONTADOR REBOTES
                    RET

;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                           SW1_FECH_AB                                       ;
; Eliminar rebotes da chave SW1 na transiao de FECHADA para ABERTA                 ;
; Usa R7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                             ;
SW1_FECH_AB:        MOV                 R7,#REBOTE_SW1
LBX9:               JNB                 SW1,SW1_FECH_AB    ;CHAVE ABERTA
                    DJNZ                R7,LBX9            ;DECREMENTAR CONTADOR REBOTES
                    RET
;

;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                           SW4_AB_FECH                                       ;
; Eliminar rebotes da chave SW4 na transiao de ABERTA para FECHADA                 ;
; Usa R7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                             ;
SW4_AB_FECH:        MOV                 R7,#REBOTE_SW4
LBX6:               JB                  SW4,SW4_AB_FECH     ;CHAVE ABERTA
                    DJNZ                R7,LBX6             ;DECREMENTAR CONTADOR REBOTES
                    RET

;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                           SW4_FECH_AB                                       ;
; Eliminar rebotes da chave SW4 na transiao de FECHADA para ABERTA                 ;
; Usa R7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                             ;
SW4_FECH_AB:        MOV                 R7,#REBOTE_SW4
LBX7:               JNB                 SW4,SW4_FECH_AB    ;CHAVE ABERTA
                    DJNZ                R7,LBX7            ;DECREMENTAR CONTADOR REBOTES
                    RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                           LCD_ESTA_OK                                       ;
; Verificar se o LCD est presente e atualizar o flag TEM_LCD                 ;
; Se receber BUSY=0, faz TEM_LCD=1, seno sai por timeout e faz TEM_LCD=0	;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                             ;
LCD_ESTA_OK:	CLR	TEM_LCD	;BIT QUE INDICA PRESENA LCD
	MOV	R7,#0	;CONTADOR PARA AS TENTATIVAS

LCDX1:	MOV	DPH,#81H
	MOV	A,#24H
	MOVX	@DPTR,A
                  
	MOV	A,#25H
	MOVX	@DPTR,A
                  
	MOV	DPH,#82H
	MOVX	A,@DPTR
	PUSH	ACC
                  
	MOV	DPH,#81H
	MOV	A,#24H
	MOVX	@DPTR,A
                  
	POP	ACC
	JNB	ACC.7,LCDX2
	DJNZ	R7,LCDX1
	RET                  
LCDX2:	SETB	TEM_LCD
	RET

	
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                          LCD_STRC                                  ;
; IMPRIME UMA STRING (TERMINAR COM 0) NO LCD                         ;
; DPTR = INICIO DA STRING NA MEMORIA DE PROGRAMA                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
LCD_STRC:       	CLR              	A
	MOVC	A,@A+DPTR	;LER UM CHAR
	JZ	LCDX4	;SE ZERO, TERMINAR
	INC	DPTR
	PUSH	DPH
                	LCALL           	LCD_WR_DADO
	POP	DPH
	SJMP	LCD_STRC
LCDX4:          	RET


;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	LCD_BCD2                                  ;
; IMPRIMIR EM DECIMAL DOIS DIGITOS BCD                               ;
; Acc = BCD A SER IMPRESSO                                           ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
LCD_BCD2:	PUSH	ACC
	SWAP	A
	ANL	A,#0FH
	ADD	A,#30H
	LCALL	LCD_CHAR
	POP	ACC
	ANL	A,#0FH
	ADD	A,#30H
	LCALL	LCD_CHAR
	RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                           LCD_INICI                                       ;
; Fazer a inicializao do LCD                  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                             ;
LCD_INIC:	LCALL	LCD_BUSY?
	MOV	A,#38H	;DL=1, N=1, F=0
	LCALL	LCD_WR_CMDO	;ESPECIFICAR FUNES
         
	LCALL	LCD_BUSY?
	MOV	A,#0FH	;D=1, C=1, B=1
	LCALL	LCD_WR_CMDO	;LIGAR/DESLIGAR
                           
	LCALL	LCD_BUSY?
	MOV	A,#6H	;I/D=1, S=0
	LCALL	LCD_WR_CMDO	;MODO DE ENTRADA

LCD_APAGA:	LCALL	LCD_BUSY?
	MOV	A,#1H	;
	LCALL	LCD_WR_CMDO	;APAGAR

LCD_HOME:	LCALL	LCD_BUSY?
	MOV	A,#2H	;
	LCALL	LCD_WR_CMDO	;HOME

	RET


;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                           LCD_WR_CMDO                                       ;
; Escrever um comando no LCD                                  ;
; A = comando a ser escrito
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                             ;
LCD_WR_CMDO:	PUSH	ACC
	LCALL	LCD_BUSY?
	MOV	DPH,#81H
	MOV	A,#20H
	MOVX	@DPTR,A
                  
	POP	ACC
	MOV	DPH,#82H
	MOVX	@DPTR,A
                  
	MOV	DPH,#81H
	MOV	A,#21H
	MOVX	@DPTR,A

	MOV	DPH,#81H
	MOV	A,#20H
	MOVX	@DPTR,A
	RET

;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                           LCD_DDRAM ou  LCD_CURSOR                                       ;
; Posio do prximo caracter                                  ;
; A = endereo a ser posicionado (7 bits)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                             ;
LCD_CURSOR:
LCD_DDRAM:	PUSH	DPH
	SETB	ACC.7	;ESPECIFICAR DDRAM
	PUSH	ACC
	LCALL	LCD_BUSY?
	MOV	DPH,#81H
	MOV	A,#20H
	MOVX	@DPTR,A
                  
	POP	ACC
	MOV	DPH,#82H
	MOVX	@DPTR,A
                  
	MOV	DPH,#81H
	MOV	A,#21H
	MOVX	@DPTR,A

	MOV	DPH,#81H
	MOV	A,#20H
	MOVX	@DPTR,A
	POP	DPH
	RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                           LCD_CGRAM                                        ;
; Posio do prximo caracter                                  ;
; A = endereo a ser posicionado (6 bits)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                             ;
LCD_CGRAM:	CLR	ACC.7	;ESPECIFICAR DDRAM
	SETB	ACC.6	
	PUSH	ACC
	LCALL	LCD_BUSY?
	MOV	DPH,#81H
	MOV	A,#20H
	MOVX	@DPTR,A
                  
	POP	ACC
	MOV	DPH,#82H
	MOVX	@DPTR,A
                  
	MOV	DPH,#81H
	MOV	A,#21H
	MOVX	@DPTR,A

	MOV	DPH,#81H
	MOV	A,#20H
	MOVX	@DPTR,A
	RET
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                           LCD_WR_DADO                                       ;
; Escrever um dado no LCD                                  ;
; A = dado a ser escrito
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LCD_CHAR:
LCD_WR_DADO:	PUSH	DPH
	PUSH	ACC

	LCALL	LCD_BUSY?
	MOV	DPH,#81H
	MOV	A,#22H
	MOVX	@DPTR,A
                  
	POP	ACC
	MOV	DPH,#82H
	MOVX	@DPTR,A
                  
	MOV	DPH,#81H
	MOV	A,#23H
	MOVX	@DPTR,A

	MOV	DPH,#81H
	MOV	A,#22H
	MOVX	@DPTR,A
	POP	DPH
	RET

;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                           LCD_BUSY?                                       ;
; Aguarda at LCD ficar desocupado (BUSY=0)                                  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                             ;
LCD_BUSY?:	JNB	TEM_LCD,LCDX9	;TEM LCD ?
	MOV	DPH,#81H
	MOV	A,#24H
	MOVX	@DPTR,A
                  
	MOV	A,#25H
	MOVX	@DPTR,A
                  
	MOV	DPH,#82H
	MOVX	A,@DPTR
	PUSH	ACC
                  
	MOV	DPH,#81H
	MOV	A,#24H
	MOVX	@DPTR,A
                  
	POP	ACC
	JB	ACC.7,LCD_BUSY?
LCDX9:	RET



;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		SER_STRC                                  ;
; Imprime uma cadeia de caracteres (termina com 0) na porta serial   ;
; A cadeia de caracteres precisa estar na memria de programa	;
; DPTR = incio da cadeia de caracteres na memria de programa       ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
SER_STRC:	CLR	A
	MOVC	A,@A+DPTR	;LER UM CHAR
                	JZ              	SERX4	;SE ZERO, TERMINAR
	INC	DPTR
                	LCALL           	SER_CHAR
                	SJMP            	SER_STRC
SERX4:          	RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		SER_BCD2                                  ;
; IMPRIMIR EM DECIMAL DOIS DIGITOS BCD NA PORTA SERIAL               ;
; Acc = BCD A SER IMPRESSO                                           ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
SER_BCD2:		PUSH	ACC
		SWAP	A
		ANL	A,#0FH
		ADD	A,#30H
		LCALL	SER_CHAR
		POP	ACC
		ANL	A,#0FH
		ADD	A,#30H
		LCALL	SER_CHAR
		RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		SER_CRLF                                  ;
; Imprime CR e LF na porta serial			;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
SER_CRLF:	MOV	A,#CR
	LCALL	SER_CHAR
	MOV	A,#LF
	LCALL	SER_CHAR
	RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                          SER_CHAR                                  ;
; Imprime um caracter na porta serial,                               ;
; monitora o flag TI at terminar a transmisso               ;
; A = caracter a ser enviado                                         ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
SER_CHAR:       	CLR             	TI
                	MOV             	SBUF,A
                	JNB             	TI,$	;AGUARDAR CARACTER SER ENVIADO
                	CLR             	TI
                	RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	TIMER_0                                  ;
; Rotina servio da interrupo do TIMER 0                               ;
; Acontece a cada 0,1 seg               ;
; A = caracter a ser enviado                                         ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
TIMER_0:	MOV	TL0,#LOW  REC50MS
	MOV	TH0,#HIGH REC50MS
	PUSH	ACC
                    PUSH	B
	PUSH	PSW
	PUSH	DPH
                    INC	CDT	;INCREMENTAR CONTADOR DE TEMPO	
	MOV	C,CDT.7	;FAZER PINO P1.1 MUDAR
	MOV	P1.1,C	;DE ESTADO A CADA 6,4 SEGUNDOS
	MOV	B,REG_FLAGS
	ANL	B,#7H	;SEPARAR OS 4 LEDS
	MOV	DPH,#END_LEDS_H
                    MOVX	A,@DPTR
                    XRL	A,B
                    MOVX	@DPTR,A
	POP	DPH
	POP	PSW
                    POP	B
	POP	ACC
TIM01:	RETI
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	APAGA_LEDS                                  ;
; Rotina para apagar os leds                                         ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
APAGA_LEDS:	MOV	DPH,#END_LEDS_H
                    MOV	A,#9FH	;LEDS APAGADOS
                    MOVX	@DPTR,A
	RET

EXTERNA_0:	RETI             
EXTERNA_1:	RETI

ACENDE_VD:     MOV            DPH,#80H
               MOV            A,#0FEH
               MOVX           @DPTR,A
               RET
               
ACENDE_AM:     MOV            DPH,#80H
               MOV            A,#0FDH
               MOVX           @DPTR,A
               RET
               
ACENDE_VM:     MOV            DPH,#80H
               MOV            A,#0FBH
               MOVX           @DPTR,A
               RET

ACENDE_AZ:     MOV            DPH,#80H
               MOV            A,#0F7H
               MOVX           @DPTR,A
               RET

ACENDE_BR:     MOV            DPH,#80H
               MOV            A,#0E7H
               MOVX           @DPTR,A
               RET

;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                        ERRO 0                                      ;
; Nao recebeu ":" ou 0DH ou 0AH                                      ;
; VM=P  AM=0  VD=0                                                   ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
ERRO0:          	CLR	REN
	LCALL	APAGA_LEDS
	CLR	PISCA_VD
	CLR	PISCA_AM
	SETB	PISCA_VM
	MOV	A,#0
	LCALL	LCD_DDRAM
	MOV             DPTR,#MSG_ERRO_0
	LCALL           LCD_STRC
	MOV             A,#40H
	LCALL           LCD_DDRAM
	MOV             DPTR,#MSG_ERRO_0A
	LCALL           LCD_STRC
	SJMP	$
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                        ERRO 1                                      ;
; Recebeu um tipo diferente de 0 ou 1                                ;
; VM=P  AM=0  VD=P                                                   ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
ERRO1:	CLR	REN
	LCALL	APAGA_LEDS
	SETB	PISCA_VD
	CLR	PISCA_AM
	SETB	PISCA_VM
                	LCALL	ACENDE_AM
	MOV	A,#0
	LCALL	LCD_DDRAM
	MOV	DPTR,#MSG_ERRO_1
	LCALL	LCD_STRC
	MOV	A,#40H
	LCALL	LCD_DDRAM
	MOV	DPTR,#MSG_ERRO_1A
	LCALL	LCD_STRC
	SJMP	$
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                        ERRO 2                                      ;
; Check sum nao conferiu                                             ;
; VM=P  AM=P  VD=0                                                   ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
ERRO2:          CLR             REN
	LCALL	APAGA_LEDS
	CLR	PISCA_VD
	SETB	PISCA_AM
	SETB	PISCA_VM
	LCALL	ACENDE_VD
                MOV             A,#0
                LCALL           LCD_DDRAM
                MOV             DPTR,#MSG_ERRO_2
                LCALL           LCD_STRC
                MOV             A,#40H
                LCALL           LCD_DDRAM
                MOV             DPTR,#MSG_ERRO_2A
                LCALL           LCD_STRC
	SJMP	$
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                        ERRO 3                                      ;
; Fila circular estourou                                             ;
; VM=P  AM=P  VD=P                                                   ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
ERRO3:		CLR	REN
		LCALL	APAGA_LEDS
		SETB	PISCA_VD
		SETB	PISCA_AM
		SETB	PISCA_VM
                MOV             A,#0
                LCALL           LCD_DDRAM
                MOV             DPTR,#MSG_ERRO_3
                LCALL           LCD_STRC
                MOV             A,#40H
                LCALL           LCD_DDRAM
                MOV             DPTR,#MSG_ERRO_3A
                LCALL           LCD_STRC
	SJMP	$
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                        ERRO 4                                      ;
; Nao conseguiu converter de ASCII para binario (ASC_HEXT)           ;
; VM=1  AM=0  VD=0                                                   ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
ERRO4:          CLR             REN
	LCALL	APAGA_LEDS
	CLR	PISCA_VD
	CLR	PISCA_AM
	CLR	PISCA_VM
                LCALL	ACENDE_VM
                MOV             A,#0
                LCALL           LCD_DDRAM
                MOV             DPTR,#MSG_ERRO_4
                LCALL           LCD_STRC
                MOV             A,#40H
                LCALL           LCD_DDRAM
                MOV             DPTR,#MSG_ERRO_4A
                LCALL           LCD_STRC
	SJMP	$
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                        ERRO 5                                      ;
; Recebeu um comando diferente de CMD_RECORD                         ;
; VM=1  AM=1  VD=0                                                   ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
ERRO5:          CLR             REN
	LCALL	APAGA_LEDS
	CLR	PISCA_VD
	CLR	PISCA_AM
	CLR	PISCA_VM
	LCALL	ACENDE_AM
                    LCALL	ACENDE_VM
                    
                MOV             A,#0
                LCALL           LCD_DDRAM
                MOV             DPTR,#MSG_ERRO_5
                LCALL           LCD_STRC
                MOV             A,#40H
                LCALL           LCD_DDRAM
                MOV             DPTR,#MSG_ERRO_5A
                LCALL           LCD_STRC
	SJMP	$



;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Mensagens que serao usadas pelo programa BOOT                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
MSG_ERRO_0:     DB              'ERRO 0:',0
MSG_ERRO_0A:    DB              'CR LF : FALTANDO',0
MSG_ERRO_1:     DB              'ERRO 1:',0
MSG_ERRO_1A:    DB              '? TIPO ? DESCON.',0
MSG_ERRO_2:     DB              'ERRO 2:',0
MSG_ERRO_2A:    DB              'CHECK SUM ERRADO',0
MSG_ERRO_3:     DB              'ERRO 3:',0
MSG_ERRO_3A:    DB              'FILA CHEIA',0
MSG_ERRO_4:     DB              'ERRO 4:',0
MSG_ERRO_4A:    DB              'ASC->HEX ERRADO',0
MSG_ERRO_5:     DB              'ERRO 5:',0
MSG_ERRO_5A:    DB              '? CMD DESCONHEC.',0

;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	MODO_TESTE                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
$INCLUDE (TESTE.ASM)


	END

