;
;+----------------------------------------------------------------------------+
;|                                                                            |
;|                         CABEC.ASM                                          |
;|                                                                25/06/2005  |
;+----------------------------------------------------------------------------+
;
; Declaraes usadas pelo BOOT1P00.ASM
;
;
; Enderecos para os Vetores de Interrupcao
RESET		EQU	0
INT_EXTERNA_0	EQU	3
INT_TIMER_0      	EQU	0BH
INT_EXTERNA_1    	EQU	13H
INT_TIMER_1     	EQU	1BH
INT_SERIAL       	EQU	23H

; Constantes
TRUE		EQU	1
FALSE		EQU	0
CR		EQU	0DH
LF		EQU	0AH
CRLF		EQU	0DAH
BAUD_4800		EQU	250		;BAUD RATE 4.800
BAUD_9600		EQU	253		;BAUD RATE 9.600
BAUD_14400	EQU	254		;BAUD RATE 14.400
BAUD_28800	EQU	255		;BAUD RATE 28.800
REC10MS		EQU	56320		;RECARGA GERAR 10mSEG (TIMER 0)
REC20MS		EQU	47104		;RECARGA GERAR 20mSEG (TIMER 0)
REC50MS		EQU	19456		;RECARGA GERAR 10mSEG (TIMER 0)
SP_INIC		EQU	5FH		;PILHA COM 32 BYTES (60->7F)
REBOTE_SW1	EQU	100		;RETARDO PARA ELIMINAR REBOTES DE SW1
REBOTE_SW4	EQU	100		;RETARDO PARA ELIMINAR REBOTES DE SW4
REC_PISCA		EQU	5		;CONTAR DEZENAS DE 0,01 SEG
TAM		EQU	20H		;TAMANHO DA FILA CIRCULAR

; Enderecos de I/O em 16 bits
END_LEDS	EQU	8000H	;LATCH COM OS LEDS
END_CTRL	EQU	8100H	;LATCH COM OS SINAIS DE CONTROLE
END_BUS_XD	EQU	8200H		;BARRAMENTO DADOS LCD (BIDIRECIONAL)
END_BUS_ZD	EQU	8300H		;BARRAMENTO ZD (SADA)
END_BUS_WD	EQU	8300H		;BARRAMENTO WD (ENTRADA)
END_PED_INT	EQU	8700H		;LER OS PEDIDOS DE INTERRUPCAO

; Enderecos de I/O, byte mais significativo
END_LEDS_H	EQU	80H		;LATCH COM OS LEDS
END_CTRL_H	EQU	81H		;LATCH COM OS SINAIS DE CONTROLE
END_BUS_XD_H	EQU	82H		;BARRAMENTO DADOS LCD (BIDIRECIONAL)
END_BUS_ZD_H	EQU	83H		;BARRAMENTO ZD (SADA)
END_BUS_WD_H	EQU	83H		;BARRAMENTO WD (ENTRADA)
END_PED_INT_H	EQU	87H		;LER OS PEDIDOS DE INTERRUPCAO

; Variveis na RAM Interna
CONTL		EQU	34H		;LSD CONTADOR DE BYTES (BCD)
CONTM		EQU	35H		;[CONTH:CONTM:CONTL]   (BCD)
CONTH		EQU	36H		;MSD CONTADOR DE BYTES (BCD)
OPTESTE		EQU	37H		;OPCAO PARA MODO TESTE
FILA		EQU	40H		;INICIO FILA CIRCULAR




; Definio de BITS
REG_FLAGS		EQU	20H
PISCA_VD		BIT	REG_FLAGS.0	;PISCAR LED VERDE
PISCA_AM		BIT	REG_FLAGS.1	;PISCAR LED AMARELO
PISCA_VM		BIT	REG_FLAGS.2	;PISCAR LED VERDE
TEM_LCD		BIT	REG_FLAGS.3	;(0=LCD AUSENTE) (1=LCD PRESENTE)
COMECOU		BIT	REG_FLAGS.6	;MARCAR INCIO DA RECEPO DO PROGRAMA
FIM		BIT	REG_FLAGS.7	;MARCAR FIM DA RECEPO DO PROGRAMA
CDT		EQU	21H

FLAG_TEMPO	BIT	CDT.3		;INSTANTE PARA MOSTRAR CONTAGEM NO LCD
SW1		BIT	P3.2		;CHAVE LIGADA AO PINO P3.2 (#INT0)
SW4		BIT	P1.0		;CHAVE LIGADA AO PINO P1.0










